>From b582ba77382aa9f1c88c323266afe10b5b2a2ca8 Mon Sep 17 00:00:00 2001
From: Roiy <roiy@cs.umanitoba.ca>
Date: Fri, 4 Oct 2013 13:57:38 -0500
Subject: [PATCH 6/9] Creation dialogs for MED

---
 .../gui/qt4/components/event_properties_widget.cpp | 372 +++++++++++++++++
 .../gui/qt4/components/event_properties_widget.hpp |  75 ++++
 modules/gui/qt4/dialogs/delete_event.cpp           | 283 +++++++++++++
 modules/gui/qt4/dialogs/delete_event.hpp           |  61 +++
 modules/gui/qt4/dialogs/edit_event.cpp             | 441 +++++++++++++++++++++
 modules/gui/qt4/dialogs/edit_event.hpp             |  71 ++++
 modules/gui/qt4/dialogs/event_properties.cpp       | 127 ++++++
 modules/gui/qt4/dialogs/event_properties.hpp       |  54 +++
 modules/gui/qt4/dialogs/events_layers.cpp          | 111 ++++++
 modules/gui/qt4/dialogs/events_layers.hpp          |  50 +++
 modules/gui/qt4/dialogs/new_layer.cpp              | 147 +++++++
 modules/gui/qt4/dialogs/new_layer.hpp              |  55 +++
 12 files changed, 1847 insertions(+)
 create mode 100644 modules/gui/qt4/components/event_properties_widget.cpp
 create mode 100644 modules/gui/qt4/components/event_properties_widget.hpp
 create mode 100644 modules/gui/qt4/dialogs/delete_event.cpp
 create mode 100644 modules/gui/qt4/dialogs/delete_event.hpp
 create mode 100644 modules/gui/qt4/dialogs/edit_event.cpp
 create mode 100644 modules/gui/qt4/dialogs/edit_event.hpp
 create mode 100644 modules/gui/qt4/dialogs/event_properties.cpp
 create mode 100644 modules/gui/qt4/dialogs/event_properties.hpp
 create mode 100644 modules/gui/qt4/dialogs/events_layers.cpp
 create mode 100644 modules/gui/qt4/dialogs/events_layers.hpp
 create mode 100644 modules/gui/qt4/dialogs/new_layer.cpp
 create mode 100644 modules/gui/qt4/dialogs/new_layer.hpp

diff --git a/modules/gui/qt4/components/event_properties_widget.cpp b/modules/gui/qt4/components/event_properties_widget.cpp
new file mode 100644
index 0000000..4dbe856
--- /dev/null
+++ b/modules/gui/qt4/components/event_properties_widget.cpp
@@ -0,0 +1,372 @@
+/*****************************************************************************
+ * event_properties_widget.cpp : Event properties tool
+ ****************************************************************************
+ * Copyright (C) 2006-2007 the VideoLAN team
+ * $Id$
+ *
+ * Author: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#define __STDC_FORMAT_MACROS 1
+#define __STDC_CONSTANT_MACROS 1
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "qt4.hpp"
+#include "components/event_properties_widget.hpp"
+#include "dialogs/event_properties.hpp"
+#include "components/interface_widgets.hpp"
+#include "dialogs/new_layer.hpp"
+
+#include <assert.h>
+#include <vlc_url.h>
+#include <vlc_meta.h>
+
+#include <QGridLayout>
+#include <QTimeEdit>
+#include <QDateTime>
+#include <QTime>
+#include <QTextEdit>
+#include <QComboBox>
+#include <QString>
+#include <QMessageBox>
+
+/************************************************************************
+ * Single panels
+ ************************************************************************/
+
+/**
+ * Event Properties Widget
+ * Event properties are displayed and modified here
+ */
+EventPropertiesWidget::EventPropertiesWidget( QWidget *parent,
+                      intf_thread_t *_p_intf )
+                      : QWidget( parent ), p_intf( _p_intf )
+{
+    bIsEditingEnd = true;
+    bLayerAdded = false;
+
+    EventPropertiesLayout = new QGridLayout( this );
+    EventPropertiesLayout->setVerticalSpacing( 0 );
+
+    QLabel *startTimeIntro = new QLabel( qtr( "Start Time:" ) );
+    startTimeIntro->setWordWrap( true );
+    startTimeIntro->setAlignment( Qt::AlignRight );
+
+    startTimeEdit = new QTimeEdit();
+    startTimeEdit->setDisplayFormat( "HH:mm:ss.zzz" );
+    startTimeEdit->setAlignment( Qt::AlignRight );
+    startTimeEdit->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+
+    EventPropertiesLayout->addWidget( startTimeIntro, 0, 0, 1, 1 );
+    EventPropertiesLayout->addWidget( startTimeEdit, 0, 1, 1, 1 );
+
+    QLabel *endTimeIntro = new QLabel( qtr( "End Time:" ) );
+    endTimeIntro->setWordWrap( true );
+    endTimeIntro->setAlignment( Qt::AlignRight );
+
+    endTimeEdit = new QTimeEdit();
+    endTimeEdit->setDisplayFormat( "HH:mm:ss.zzz" );
+    endTimeEdit->setAlignment( Qt::AlignRight );
+    endTimeEdit->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+
+    EventPropertiesLayout->addWidget( endTimeIntro, 1, 0, 1, 1 );
+    EventPropertiesLayout->addWidget( endTimeEdit, 1, 1, 1, 1 );
+
+    CONNECT( startTimeEdit, timeChanged( QTime ), this, startTimeUpdate( QTime newTime ) );
+    CONNECT( endTimeEdit, timeChanged( QTime ), this, endTimeUpdate( QTime newTime ) );
+
+
+    QLabel* label = new QLabel( qtr( N_("Events Layer: ") ) ); 
+    label->setContentsMargins( 3, 2, 0, 0 );
+    label->setAlignment( Qt::AlignRight );
+    EventPropertiesLayout->addWidget( label, 3, 0 );
+
+    layersCombo = new QComboBox( this );
+    layersCombo->setObjectName(QString::fromUtf8("layersCombo"));
+    QSizePolicy sizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Fixed);
+    sizePolicy.setHorizontalStretch(0);
+    sizePolicy.setVerticalStretch(0);
+    sizePolicy.setHeightForWidth(layersCombo->sizePolicy().hasHeightForWidth());
+    layersCombo->setSizePolicy(sizePolicy);
+
+    EventPropertiesLayout->addWidget(layersCombo, 3, 1);
+
+    QPushButton *newLayerButton = new QPushButton( qtr( "&New" ) );
+    newLayerButton->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+    EventPropertiesLayout->addWidget(newLayerButton, 3, 2);
+
+    CONNECT( newLayerButton, clicked(), this, addLayer() );
+
+    EventPropertiesLayout->setVerticalSpacing(5);
+
+    label = new QLabel( qtr( N_("Annotation:") ) ); 
+    label->setContentsMargins( 3, 2, 0, 0 );
+    EventPropertiesLayout->addWidget( label, 5, 0, 1, 7 );
+    annotation_text = new QTextEdit;
+    annotation_text->setAcceptRichText( false );
+    EventPropertiesLayout->addWidget( annotation_text, 6, 0, 1, 7 );
+
+    //EventsLayersLayout->setColumnStretch( 1, 20 );
+    //EventsLayersLayout->setColumnMinimumWidth ( 1, 80 );
+    //EventsLayersLayout->setRowStretch( line, 10 );
+
+    CONNECT( THEMIM->getIM(), eventsChanged( bool ), this, update( bool ) );
+    CONNECT( THEMIM->getIM(), switchEdit( bool, int64_t ),
+        this, setEditingMode( bool ) );
+    CONNECT( THEMIM->getIM(), positionUpdated( float, int64_t, int ),
+        this, updateSegTimes( float, int64_t, int ) );
+
+    newLayerDialog = NewLayerDialog::getInstance( p_intf );
+    CONNECT( newLayerDialog, layerAdded( QString ), this, layerAdded( QString ) );
+
+    update( true );
+}
+
+
+void EventPropertiesWidget::update( bool inputExists )//ROIY - inputexists
+{
+    clear();
+
+    if ( !inputExists )
+    {
+        bIsEditingEnd = true;
+        return;
+    }
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+    
+    const char* pszSlave = "med";
+    bool b_exists;
+
+    input_Control( p_input, INPUT_CHECK_SLAVE_EXISTS, pszSlave, &b_exists );    //Check if med module was already active
+
+    if ( !b_exists )    //med module was not active until now, intialize it with an empty file
+        if ( input_Control( p_input, INPUT_SAVE_ENHANCEMENT_FILE ) != VLC_SUCCESS )
+        {
+            vlc_object_release( p_input );
+            return;
+        }
+
+
+    int* pi_layers;
+    char*** psz_layerNames;
+    if ( input_Control( p_input, INPUT_GET_LAYER_NAMES, &psz_layerNames, &pi_layers ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    layersCombo->addItem( qtr( "" ) );
+    for ( int i = 0; i < *pi_layers ; i++ )
+        layersCombo->addItem( qtr( (*psz_layerNames)[i] ) );
+
+    vlc_object_release( p_input );
+}
+
+void EventPropertiesWidget::updateSegTimes( float pos, int64_t t, int length )
+{
+    VLC_UNUSED( length );
+
+    if ( pos == -1.f )
+        return;
+    
+    bool bFirstSet = false; 
+
+    long time = t / 1000;
+    int ms = time % 1000;
+    
+    time /= 1000;
+    int seconds = time % 60;
+
+    time /= 60;
+    int minutes = time % 60;
+
+    time /= 60;
+    int hours = time;
+
+    QTime newTime;
+    newTime.setHMS( hours, minutes, seconds, ms );
+        
+    if ( ( startTimeEdit->time() == QTime( 0,0,0 ) ) && ( endTimeEdit->time() == QTime( 0,0,0 ) ) )
+        bFirstSet = true;   /* On first use only, we need both times as the current marker */
+
+    /* update time and prevent circular updating by not triggeting the signal */
+    if ( bIsEditingEnd )
+    {
+        disconnect( endTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( endTimeUpdate( QTime ) ) );
+        endTimeEdit->setTime( newTime );
+        CONNECT( endTimeEdit, timeChanged( QTime ), this, endTimeUpdate( QTime ) );
+
+        if ( endTimeEdit->time() < startTimeEdit->time() )  //Avoid end before start
+        {
+            disconnect( startTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( startTimeUpdate( QTime ) ) );
+            startTimeEdit->setTime( newTime );
+            CONNECT( startTimeEdit, timeChanged( QTime ), this, startTimeUpdate( QTime ) );
+        }
+
+    }
+    if ( !bIsEditingEnd || bFirstSet )
+    {
+        disconnect( startTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( startTimeUpdate( QTime ) ) );
+        startTimeEdit->setTime( newTime );
+        CONNECT( startTimeEdit, timeChanged( QTime ), this, startTimeUpdate( QTime ) );
+
+        if ( endTimeEdit->time() < startTimeEdit->time() )  //Avoid end before start
+        {
+            disconnect( endTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( endTimeUpdate( QTime ) ) );
+            endTimeEdit->setTime( newTime );
+            CONNECT( endTimeEdit, timeChanged( QTime ), this, endTimeUpdate( QTime ) );
+        }
+    }
+}
+
+/* sends playback commands according to the time set in the startTimeEdit */
+void EventPropertiesWidget::startTimeUpdate( QTime newTime )
+{
+    int64_t i_time = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( newTime ) ) * 1000;
+
+    THEMIM->getIM()->setEventTimes( i_time, (int64_t)-1 );
+}
+
+/* sends playback commands according to the time set in the endTimeEdit */
+void EventPropertiesWidget::endTimeUpdate( QTime newTime )
+{
+    int64_t i_time = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( newTime ) ) * 1000;
+
+    THEMIM->getIM()->setEventTimes( (int64_t)-1, i_time );
+}
+
+/* Switches between editing the start or the end of the segment, with the last point where the marker was when swapped */
+void EventPropertiesWidget::setEditingMode( bool bIsSegEndEdit )
+{
+    bIsEditingEnd = bIsSegEndEdit;
+
+    //updateSegTimes( 0, timeSwapped, 0 );  //ROIY is this happening before receiving the signal of updated?
+}
+
+
+void EventPropertiesWidget::saveEvent()
+{
+    if ( layersCombo->currentIndex() == 0 )
+    {
+        QMessageBox msgBox;
+        msgBox.setText( "<p align='center'>Please pick an Event Layer</p>" );
+        msgBox.exec();
+        return;
+    }
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    /* Add layer if needed */
+
+    if ( bLayerAdded && ( layersCombo->currentIndex() == layersCombo->count() - 1 ) )
+    {
+
+        char* newLayer = strdup ( (char*) qtu( layersCombo->currentText() ) );
+
+        if ( input_Control( p_input, INPUT_ADD_LAYER, &newLayer ) != VLC_SUCCESS )
+        {
+            vlc_object_release( p_input );
+            return;
+        }  
+        msg_Err(p_input, "RoiyNewLayer: name: %s, layerId: %d", newLayer, layersCombo->currentIndex()-1 );//ROIY REMOVE
+        bLayerAdded = false;
+    }
+
+    int i_idx;
+    int64_t startTime = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( startTimeEdit->time() ) ) * 1000;
+
+    if ( input_Control( p_input, INPUT_GET_NEXT_SEGMENT_IDX, &i_idx, startTime ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }    
+    
+    int64_t endTime = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( endTimeEdit->time() ) ) * 1000;
+
+    //Build new event segment
+    seeksegment_t* newSegment = vlc_seeksegment_New();
+    newSegment->eventNum = 0;
+    newSegment->psz_layerName = strdup( (char*) qtu( layersCombo->currentText() ) );
+    newSegment->i_layer_id = layersCombo->currentIndex() - 1;
+    newSegment->i_time_offset = startTime;
+    newSegment->i_time_duration = endTime - startTime;
+    char* newAnnotation = (char*) qtu( annotation_text->toPlainText() );
+    newAnnotation = strcat( newAnnotation, "\n");
+    newSegment->psz_text = strdup( newAnnotation );
+
+
+    if ( input_Control( p_input, INPUT_SET_SEGMENT_AT_IDX, newSegment, i_idx, newSegment->i_layer_id ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    vlc_object_release( p_input );
+
+    msg_Err(p_input, "RoiyCreate: event in layer %s, index: %d, startTime:%ld, duration:%ld", newSegment->psz_layerName, i_idx, newSegment->i_time_offset, newSegment->i_time_duration );//ROIY REMOVE
+
+    vlc_seeksegment_Delete( newSegment );
+
+    
+    THEMIM->getIM()->eventsModified();
+
+    ( ( EventPropertiesDialog* ) parent() )->close();
+}
+
+void EventPropertiesWidget::addLayer()
+{
+    newLayerDialog->toggleVisible();
+}
+
+void EventPropertiesWidget::layerAdded( QString newLayer )
+{
+    if ( !bLayerAdded )
+        layersCombo->addItem( newLayer );
+    else
+        layersCombo->setItemText( layersCombo->count() - 1, newLayer );     //Just update the layer name to be added
+
+    layersCombo->setCurrentIndex( layersCombo->count() - 1 );
+
+    bLayerAdded = true;
+}
+
+void EventPropertiesWidget::clear()
+{
+    startTimeEdit->clear();
+    startTimeEdit->setTime( QTime( 0, 0, 0) );
+    endTimeEdit->clear();
+    endTimeEdit->setTime( QTime( 0, 0, 0) );
+    annotation_text->clear();
+    layersCombo->clear();
+    
+    bIsEditingEnd = true;
+    bLayerAdded = false;
+}
+
+EventPropertiesWidget::~EventPropertiesWidget()
+{
+    clear();
+    delete EventPropertiesLayout;
+}
\ No newline at end of file
diff --git a/modules/gui/qt4/components/event_properties_widget.hpp b/modules/gui/qt4/components/event_properties_widget.hpp
new file mode 100644
index 0000000..8c45d57
--- /dev/null
+++ b/modules/gui/qt4/components/event_properties_widget.hpp
@@ -0,0 +1,75 @@
+/*****************************************************************************
+ * event_properties_widget.hpp : Event Properties modification tool
+ ****************************************************************************
+ * Copyright (C) 2006-2007 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef _EVENTPROPERTIESWIDGET_H_
+#define _EVENTPROPERTIESWIDGET_H_
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include <vlc_meta.h>
+#include "dialogs/new_layer.hpp"
+
+#include <QWidget>
+
+#include <limits.h>
+#include <vector>
+#include <QDateTime>
+
+class QTextEdit;
+class QTimeEdit;
+class QTime;
+class QComboBox;
+
+class EventPropertiesWidget: public QWidget
+{
+    Q_OBJECT
+public:
+    EventPropertiesWidget( QWidget *, struct intf_thread_t * );
+    ~EventPropertiesWidget();
+    QGridLayout *EventPropertiesLayout;
+    bool bIsEditingEnd;
+private:
+    struct intf_thread_t *p_intf;
+    QTimeEdit *startTimeEdit;
+    QTimeEdit *endTimeEdit;
+    QTextEdit *annotation_text;
+    QComboBox *layersCombo;
+    NewLayerDialog * newLayerDialog;
+    bool bLayerAdded;
+
+public slots:
+    void update( bool inputExists );
+    void setEditingMode( bool bIsSegEndEdit );
+    void updateSegTimes( float pos, int64_t t, int length );
+    void startTimeUpdate( QTime newTime );
+    void endTimeUpdate( QTime newTime );
+    void addLayer();
+    void layerAdded( QString newLayer );
+    void saveEvent();
+    void clear();
+};
+
+#endif
diff --git a/modules/gui/qt4/dialogs/delete_event.cpp b/modules/gui/qt4/dialogs/delete_event.cpp
new file mode 100644
index 0000000..620f8cc
--- /dev/null
+++ b/modules/gui/qt4/dialogs/delete_event.cpp
@@ -0,0 +1,283 @@
+/*****************************************************************************
+ * delete_event.cpp : delete_event display
+ ****************************************************************************
+ * Copyright (C) 2006-2008 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "dialogs/delete_event.hpp"
+#include "input_manager.hpp"
+
+#include <QPushButton>
+#include <QTextEdit>
+#include <QLabel>
+#include <QDialogButtonBox>
+#include <QTimeEdit>
+#include <QDateTime>
+#include <QTime>
+
+
+DeleteEventDialog::DeleteEventDialog( intf_thread_t *_p_intf )
+               : QVLCDialog( (QWidget*)_p_intf->p_sys->p_mi, _p_intf )
+{
+#ifdef __APPLE__
+    setWindowFlags( Qt::Drawer );
+#else
+    setWindowFlags( Qt::Tool );
+#endif
+
+    setWindowOpacity( var_InheritFloat( p_intf, "qt-opacity" ) );
+    setWindowTitle( qtr( "Delete Event" ) );
+    setWindowRole( "vlc-deleteEvent" );
+
+    eventIndex = -1;
+    eventLayer = -1;
+}
+
+void DeleteEventDialog::deleteEvent()
+{
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    if ( input_Control( p_input, INPUT_DELETE_SEGMENT_AT_IDX, eventIndex, eventLayer ) != VLC_SUCCESS )  
+    {
+        msg_Err( p_input, "Could not delete event with id=%d ", eventIndex);
+        vlc_object_release( p_input );
+        return;
+    }
+
+    msg_Err(p_input, "RoiyDelete: event in layer %d, index: %d", eventLayer, eventIndex );//ROIY REMOVE
+    vlc_object_release( p_input );
+
+    THEMIM->getIM()->eventsModified();
+
+    close();
+}
+
+void DeleteEventDialog::update()
+{
+    mainLayout = new QGridLayout( this );
+    mainLayout->setContentsMargins( 1, 1, 1, 1 );
+    mainLayout->setSpacing( 2 );
+    mainLayout->setSizeConstraint( QLayout::SetFixedSize );
+
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    seeksegment_t *p_event = NULL;
+    
+    if ( input_Control( p_input, INPUT_GET_ANNOTATIONS, &p_event, &eventIndex, (int64_t)(-1), -1 ) != VLC_SUCCESS )  //Get active event in current time
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    vlc_object_release( p_input );
+
+
+    if ( !p_event )
+    {
+        QLabel* errorLabel = new QLabel( qtr( "No event was found in the current time point, please select an active event." ) );
+
+        mainLayout->addWidget( errorLabel, 0, 0, 1, 1 );
+
+        QDialogButtonBox *okButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+        okButtonBox->addButton( new QPushButton( qtr("&Ok"), this ), QDialogButtonBox::AcceptRole );
+
+        mainLayout->addWidget( okButtonBox, 1, 0, 1, 1, Qt::AlignCenter );
+
+        CONNECT( okButtonBox, accepted(), this, toggleVisible() );
+
+        return;
+    }
+
+
+    QLabel *deleteIntro = new QLabel( qtr( "Are you sure you want to delete this event?" ) );
+    deleteIntro->setAlignment( Qt::AlignCenter );
+    
+    mainLayout->addWidget( deleteIntro, 0, 0, 1, 2 );
+
+    QLabel *startTimeIntro = new QLabel( qtr( "Start Time:" ) );
+    startTimeIntro->setWordWrap( true );
+    startTimeIntro->setAlignment( Qt::AlignRight );
+
+    startTimeEdit = new QTimeEdit();
+    startTimeEdit->setDisplayFormat( "HH:mm:ss.zzz" );
+    startTimeEdit->setAlignment( Qt::AlignLeft );
+    startTimeEdit->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+    startTimeEdit->setEnabled( false );
+
+    int64_t t = p_event->i_time_offset;
+
+    long time = t / 1000;
+    int ms = time % 1000;
+    
+    time /= 1000;
+    int seconds = time % 60;
+
+    time /= 60;
+    int minutes = time % 60;
+
+    time /= 60;
+    int hours = time;
+
+    QTime startTime;
+    startTime.setHMS( hours, minutes, seconds, ms );
+    startTimeEdit->setTime( startTime );
+
+    mainLayout->addWidget( startTimeIntro, 1, 0, 1, 1 );
+    mainLayout->addWidget( startTimeEdit, 1, 1, 1, 1 );
+
+    QLabel *endTimeIntro = new QLabel( qtr( "End Time:" ) );
+    endTimeIntro->setWordWrap( true );
+    endTimeIntro->setAlignment( Qt::AlignRight );
+
+    endTimeEdit = new QTimeEdit();
+    endTimeEdit->setDisplayFormat( "HH:mm:ss.zzz" );
+    endTimeEdit->setAlignment( Qt::AlignLeft );
+    endTimeEdit->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+    endTimeEdit->setEnabled( false );
+
+
+    t = p_event->i_time_offset + p_event->i_time_duration;
+
+    time = t / 1000;
+    ms = time % 1000;
+    
+    time /= 1000;
+    seconds = time % 60;
+
+    time /= 60;
+    minutes = time % 60;
+
+    time /= 60;
+    hours = time;
+
+    QTime endTime;
+    endTime.setHMS( hours, minutes, seconds, ms );
+    endTimeEdit->setTime( endTime );
+
+    mainLayout->addWidget( endTimeIntro, 2, 0, 1, 1 );
+    mainLayout->addWidget( endTimeEdit, 2, 1, 1, 1 );
+
+
+    QLabel* layerIntro = new QLabel( qtr( N_("Events Layer: ") ) ); 
+    layerIntro->setContentsMargins( 3, 2, 0, 0 );
+    layerIntro->setAlignment( Qt::AlignRight );
+    mainLayout->addWidget( layerIntro, 3, 0, 1, 1 );
+
+    QLabel* layer = new QLabel( qtr( p_event->psz_layerName ) ); 
+    layer->setContentsMargins( 3, 2, 0, 0 );
+    layer->setAlignment( Qt::AlignLeft );
+    mainLayout->addWidget( layer, 3, 1, 1, 1 );
+
+    eventLayer = p_event->i_layer_id;
+
+    QLabel* idIntro = new QLabel( qtr( N_("Event Id: ") ) ); 
+    idIntro->setContentsMargins( 3, 2, 0, 0 );
+    idIntro->setAlignment( Qt::AlignRight );
+    mainLayout->addWidget( idIntro, 4, 0, 1, 1 );
+
+    QLabel* id = new QLabel( QString::number( p_event->eventNum ) ); 
+    id->setContentsMargins( 3, 2, 0, 0 );
+    id->setAlignment( Qt::AlignLeft );
+    mainLayout->addWidget( id, 4, 1, 1, 1 );
+
+    mainLayout->setVerticalSpacing(5);
+
+    QLabel* annotationIntro = new QLabel( qtr( N_("Annotation:") ) ); 
+    annotationIntro->setContentsMargins( 3, 2, 0, 0 );
+    mainLayout->addWidget( annotationIntro, 5, 0, 1, 7 );
+
+    annotation_text = new QTextEdit( qtr( p_event->psz_text ) );
+    annotation_text->setAcceptRichText( false );
+    annotation_text->setReadOnly( true );
+    mainLayout->addWidget( annotation_text, 6, 0, 1, 7 );
+    ////////////
+
+    QDialogButtonBox *deleteButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    deleteButtonBox->addButton(
+        new QPushButton( qtr("&Delete"), this ), QDialogButtonBox::AcceptRole );
+
+    QDialogButtonBox *closeButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    closeButtonBox->addButton(
+        new QPushButton( qtr("&Cancel"), this ), QDialogButtonBox::RejectRole );
+
+    QHBoxLayout *buttonLayout = new QHBoxLayout( this );
+    buttonLayout->setSpacing( 0 );
+    buttonLayout->setContentsMargins( 0, 0, 0, 0 );
+    buttonLayout->addStretch( 1 );
+    buttonLayout->addWidget( deleteButtonBox, 0 , Qt::AlignRight  );
+    buttonLayout->addWidget( closeButtonBox, 0 , Qt::AlignRight  );
+    mainLayout->addLayout( buttonLayout, 7, 0, 1, 2 );
+
+    CONNECT( closeButtonBox, rejected(), this, toggleVisible() );
+    CONNECT( deleteButtonBox, accepted(), this, deleteEvent() );
+
+    QVLCTools::restoreWidgetPosition( p_intf, "DeleteEventDialog", this );
+
+    vlc_seeksegment_Delete( p_event );
+}
+
+void DeleteEventDialog::clear()
+{
+    if ( mainLayout != NULL )
+    {
+        QLayoutItem* item;
+        while ( ( item = mainLayout->takeAt( 0 ) ) != NULL )
+        {
+            delete item->widget();
+            delete item;
+        }
+        delete mainLayout;
+        mainLayout = NULL;
+    }
+
+    eventIndex = -1;
+    eventLayer = -1;
+}
+
+void DeleteEventDialog::close()
+{
+    QVLCDialog::close();
+    clear();
+}
+
+void DeleteEventDialog::toggleVisible()
+{
+    if( isVisible() ) 
+        close();
+    else
+    {
+        update();
+        show();
+    }
+}
+
+DeleteEventDialog::~DeleteEventDialog()
+{
+    QVLCTools::saveWidgetPosition( p_intf, "DeleteEventDialog", this );
+    clear();
+}
\ No newline at end of file
diff --git a/modules/gui/qt4/dialogs/delete_event.hpp b/modules/gui/qt4/dialogs/delete_event.hpp
new file mode 100644
index 0000000..1b4f4e9
--- /dev/null
+++ b/modules/gui/qt4/dialogs/delete_event.hpp
@@ -0,0 +1,61 @@
+/*****************************************************************************
+ * delete_event.hpp : Delete Event
+ ****************************************************************************
+ * Copyright (C) 2006 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef QVLC_DELETE_EVENT_DIALOG_H_
+#define QVLC_DELETE_EVENT_DIALOG_H_ 1
+
+#include "util/qvlcframe.hpp"
+
+#include "util/singleton.hpp"
+
+#include <QDateTime>
+
+class QTextEdit;
+class QTimeEdit;
+class QTime;
+
+class DeleteEventDialog : public QVLCDialog, public Singleton<DeleteEventDialog>
+{
+    Q_OBJECT
+private:
+    DeleteEventDialog( intf_thread_t * );
+    virtual ~DeleteEventDialog();
+    QGridLayout *mainLayout;
+    QTimeEdit *startTimeEdit;
+    QTimeEdit *endTimeEdit;
+    QTextEdit *annotation_text;
+    int eventIndex, eventLayer;
+
+private slots:
+    friend class    Singleton<DeleteEventDialog>;
+    void deleteEvent();
+    void clear();
+    void update();
+    void close();
+
+public slots:
+    void toggleVisible();
+};
+
+#endif
+
diff --git a/modules/gui/qt4/dialogs/edit_event.cpp b/modules/gui/qt4/dialogs/edit_event.cpp
new file mode 100644
index 0000000..78fc858
--- /dev/null
+++ b/modules/gui/qt4/dialogs/edit_event.cpp
@@ -0,0 +1,441 @@
+/*****************************************************************************
+ * edit_event.cpp : edit_event display
+ ****************************************************************************
+ * Copyright (C) 2006-2008 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "dialogs/edit_event.hpp"
+#include "input_manager.hpp"
+
+#include <QPushButton>
+#include <QTextEdit>
+#include <QLabel>
+#include <QDialogButtonBox>
+#include <QTimeEdit>
+#include <QDateTime>
+#include <QTime>
+#include <QComboBox>
+
+
+EditEventDialog::EditEventDialog( intf_thread_t *_p_intf )
+               : QVLCDialog( (QWidget*)_p_intf->p_sys->p_mi, _p_intf )
+{
+#ifdef __APPLE__
+    setWindowFlags( Qt::Drawer );
+#else
+    setWindowFlags( Qt::Tool );
+#endif
+
+    setWindowOpacity( var_InheritFloat( p_intf, "qt-opacity" ) );
+    setWindowTitle( qtr( "Edit Event" ) );
+    setWindowRole( "vlc-editEvent" );
+
+    eventIndex = -1;
+    eventLayer = -1;
+    bIsEditingEnd = true;
+    p_event = NULL;
+}
+
+void EditEventDialog::editEvent()
+{
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    int64_t startTime = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( startTimeEdit->time() ) ) * 1000;
+
+    int64_t endTime = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( endTimeEdit->time() ) ) * 1000;
+
+    free( p_event->psz_layerName );
+    p_event->psz_layerName = strdup( (char*) qtu( layersCombo->currentText() ) );
+    p_event->i_layer_id = layersCombo->currentIndex();
+    p_event->i_time_offset = startTime;
+    p_event->i_time_duration = endTime - startTime;
+    free( p_event->psz_text );
+    char* newAnnotation = (char*) qtu( annotation_text->toPlainText() );
+    newAnnotation = strcat( newAnnotation, "\n");
+    p_event->psz_text = strdup( newAnnotation );
+
+    if ( input_Control( p_input, INPUT_REPLACE_SEGMENT_AT_IDX, p_event, eventIndex ) != VLC_SUCCESS )  
+    {
+        msg_Err( p_input, "Could not edit event with id=%d ", eventIndex);
+        vlc_object_release( p_input );
+        return;
+    }
+
+    msg_Err(p_input, "RoiyEdit: event in index: %d", eventIndex );//ROIY REMOVE
+    vlc_object_release( p_input );
+
+    THEMIM->getIM()->eventsModified();
+
+    close();
+}
+
+void EditEventDialog::update()
+{
+    mainLayout = new QGridLayout( this );
+    mainLayout->setContentsMargins( 1, 1, 1, 1 );
+    mainLayout->setSpacing( 2 );
+    mainLayout->setSizeConstraint( QLayout::SetFixedSize );
+
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    if ( input_Control( p_input, INPUT_GET_ANNOTATIONS, &p_event, &eventIndex, (int64_t)(-1), -1 ) != VLC_SUCCESS )  //Get active event in current time
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    if ( !p_event )
+    {
+        vlc_object_release( p_input );
+
+        QLabel* errorLabel = new QLabel( qtr( "No event was found in the current time point, please select an active event." ) );
+
+        mainLayout->addWidget( errorLabel, 0, 0, 1, 1 );
+
+        QDialogButtonBox *okButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+        okButtonBox->addButton( new QPushButton( qtr("&Ok"), this ), QDialogButtonBox::AcceptRole );
+
+        mainLayout->addWidget( okButtonBox, 1, 0, 1, 1, Qt::AlignCenter );
+
+        CONNECT( okButtonBox, accepted(), this, close() );
+
+        return;
+    }
+
+
+
+    QLabel *editIntro = new QLabel( qtr( "Are you sure you want to edit this event?" ) );
+    editIntro->setAlignment( Qt::AlignCenter );
+    
+    mainLayout->addWidget( editIntro, 0, 0, 1, 2 );
+
+    QLabel *orgStartTimeIntro = new QLabel( qtr( "Original Start Time:" ) );
+    orgStartTimeIntro->setWordWrap( true );
+    orgStartTimeIntro->setAlignment( Qt::AlignRight );
+
+    orgStartTime = new QTimeEdit();
+    orgStartTime->setDisplayFormat( "HH:mm:ss.zzz" );
+    orgStartTime->setAlignment( Qt::AlignLeft );
+    orgStartTime->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+    orgStartTime->setEnabled( false );
+
+    int64_t t = p_event->i_time_offset;
+
+    long time = t / 1000;
+    int ms = time % 1000;
+    
+    time /= 1000;
+    int seconds = time % 60;
+
+    time /= 60;
+    int minutes = time % 60;
+
+    time /= 60;
+    int hours = time;
+
+    QTime startTime;
+    startTime.setHMS( hours, minutes, seconds, ms );
+    orgStartTime->setTime( startTime );
+
+    mainLayout->addWidget( orgStartTimeIntro, 1, 0, 1, 1 );
+    mainLayout->addWidget( orgStartTime, 1, 1, 1, 1 );
+
+    QLabel *startTimeIntro = new QLabel( qtr( "Start Time:" ) );
+    startTimeIntro->setWordWrap( true );
+    startTimeIntro->setAlignment( Qt::AlignRight );
+
+    startTimeEdit = new QTimeEdit();
+    startTimeEdit->setDisplayFormat( "HH:mm:ss.zzz" );
+    startTimeEdit->setAlignment( Qt::AlignLeft );
+    startTimeEdit->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+
+    mainLayout->addWidget( startTimeIntro, 2, 0, 1, 1 );
+    mainLayout->addWidget( startTimeEdit, 2, 1, 1, 1 );
+
+    QLabel *orgEndTimeIntro = new QLabel( qtr( "Original End Time:" ) );
+    orgEndTimeIntro->setWordWrap( true );
+    orgEndTimeIntro->setAlignment( Qt::AlignRight );
+
+    orgEndTime = new QTimeEdit();
+    orgEndTime->setDisplayFormat( "HH:mm:ss.zzz" );
+    orgEndTime->setAlignment( Qt::AlignLeft );
+    orgEndTime->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+    orgEndTime->setEnabled( false );
+
+
+    t = p_event->i_time_offset + p_event->i_time_duration;
+
+    time = t / 1000;
+    ms = time % 1000;
+    
+    time /= 1000;
+    seconds = time % 60;
+
+    time /= 60;
+    minutes = time % 60;
+
+    time /= 60;
+    hours = time;
+
+    QTime endTime;
+    endTime.setHMS( hours, minutes, seconds, ms );
+    orgEndTime->setTime( endTime );
+
+    mainLayout->addWidget( orgEndTimeIntro, 3, 0, 1, 1 );
+    mainLayout->addWidget( orgEndTime, 3, 1, 1, 1 );
+
+    QLabel *endTimeIntro = new QLabel( qtr( "End Time:" ) );
+    endTimeIntro->setWordWrap( true );
+    endTimeIntro->setAlignment( Qt::AlignRight );
+
+    endTimeEdit = new QTimeEdit();
+    endTimeEdit->setDisplayFormat( "HH:mm:ss.zzz" );
+    endTimeEdit->setAlignment( Qt::AlignLeft );
+    endTimeEdit->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Minimum );
+
+    mainLayout->addWidget( endTimeIntro, 4, 0, 1, 1 );
+    mainLayout->addWidget( endTimeEdit, 4, 1, 1, 1 );
+
+    CONNECT( startTimeEdit, timeChanged( QTime ), this, startTimeUpdate( QTime newTime ) );
+    CONNECT( endTimeEdit, timeChanged( QTime ), this, endTimeUpdate( QTime newTime ) );
+
+
+    QLabel* layerIntro = new QLabel( qtr( N_("Events Layer: ") ) ); 
+    layerIntro->setContentsMargins( 3, 2, 0, 0 );
+    layerIntro->setAlignment( Qt::AlignRight );
+    mainLayout->addWidget( layerIntro, 5, 0, 1, 1 );
+
+    layersCombo = new QComboBox( this );
+    layersCombo->setObjectName(QString::fromUtf8("layersCombo"));
+    QSizePolicy sizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Fixed);
+    sizePolicy.setHorizontalStretch(0);
+    sizePolicy.setVerticalStretch(0);
+    sizePolicy.setHeightForWidth(layersCombo->sizePolicy().hasHeightForWidth());
+    layersCombo->setSizePolicy(sizePolicy);
+
+    //Get options for layers
+    int* pi_layers;
+    char*** psz_layerNames;
+    if ( input_Control( p_input, INPUT_GET_LAYER_NAMES, &psz_layerNames, &pi_layers ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    for ( int i = 0; i < *pi_layers ; i++ )
+        layersCombo->addItem( qtr( (*psz_layerNames)[i] ) );
+
+    vlc_object_release( p_input );
+
+    eventLayer = p_event->i_layer_id;
+    layersCombo->setCurrentIndex( eventLayer );
+
+    mainLayout->addWidget(layersCombo, 5, 1, 1, 1);
+
+    
+
+    QLabel* idIntro = new QLabel( qtr( N_("Event Id: ") ) ); 
+    idIntro->setContentsMargins( 3, 2, 0, 0 );
+    idIntro->setAlignment( Qt::AlignRight );
+    mainLayout->addWidget( idIntro, 6, 0, 1, 1 );
+
+    QLabel* id = new QLabel( QString::number( p_event->eventNum ) ); 
+    id->setContentsMargins( 3, 2, 0, 0 );
+    id->setAlignment( Qt::AlignLeft );
+    mainLayout->addWidget( id, 6, 1, 1, 1 );
+
+    mainLayout->setVerticalSpacing(5);
+
+    QLabel* annotationIntro = new QLabel( qtr( N_("Annotation:") ) ); 
+    annotationIntro->setContentsMargins( 3, 2, 0, 0 );
+    mainLayout->addWidget( annotationIntro, 7, 0, 1, 7 );
+
+    annotation_text = new QTextEdit( qtr( p_event->psz_text ) );
+    annotation_text->setAcceptRichText( false );
+    mainLayout->addWidget( annotation_text, 8, 0, 1, 7 );
+    ////////////
+
+    QDialogButtonBox *editButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    editButtonBox->addButton(
+        new QPushButton( qtr("&Edit"), this ), QDialogButtonBox::AcceptRole );
+
+    QDialogButtonBox *closeButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    closeButtonBox->addButton(
+        new QPushButton( qtr("&Cancel"), this ), QDialogButtonBox::RejectRole );
+
+    QHBoxLayout *buttonLayout = new QHBoxLayout( this );
+    buttonLayout->setSpacing( 0 );
+    buttonLayout->setContentsMargins( 0, 0, 0, 0 );
+    buttonLayout->addStretch( 1 );
+    buttonLayout->addWidget( editButtonBox, 0 , Qt::AlignRight  );
+    buttonLayout->addWidget( closeButtonBox, 0 , Qt::AlignRight  );
+    mainLayout->addLayout( buttonLayout, 9, 0, 1, 2 );
+
+    CONNECT( closeButtonBox, rejected(), this, toggleVisible() );
+    CONNECT( editButtonBox, accepted(), this, editEvent() );
+
+    QVLCTools::restoreWidgetPosition( p_intf, "EditEventDialog", this );
+
+    // ROIY ? CONNECT( THEMIM->getIM(), eventsChanged( bool ), this, update( bool ) );
+    CONNECT( THEMIM->getIM(), switchEdit( bool, int64_t ),
+        this, setEditingMode( bool ) );
+    CONNECT( THEMIM->getIM(), positionUpdated( float, int64_t, int ),
+        this, updateSegTimes( float, int64_t, int ) );
+}
+
+void EditEventDialog::clear()
+{
+    disconnect( THEMIM->getIM(), SIGNAL( switchEdit( bool, int64_t ) ),
+        this, SLOT( setEditingMode( bool ) ) );
+    disconnect( THEMIM->getIM(), SIGNAL( positionUpdated( float, int64_t, int ) ),
+        this, SLOT( updateSegTimes( float, int64_t, int ) ) );
+
+    if ( mainLayout != NULL )
+    {
+        QLayoutItem* item;
+        while ( ( item = mainLayout->takeAt( 0 ) ) != NULL )
+        {
+            delete item->widget();
+            delete item;
+        }
+        delete mainLayout;
+        mainLayout = NULL;
+    }
+
+    eventIndex = -1;
+    eventLayer = -1;
+    bIsEditingEnd = true;
+    vlc_seeksegment_Delete( p_event );
+    p_event = NULL;
+}
+
+void EditEventDialog::close()
+{
+    THEMIM->getIM()->toggleEditing();
+    QVLCDialog::close();
+    clear();
+}
+
+void EditEventDialog::toggleVisible()
+{
+    if( isVisible() ) 
+        close();
+    else
+    {
+        update();
+        THEMIM->getIM()->toggleEditing();
+        show();
+    }
+}
+
+void EditEventDialog::updateSegTimes( float pos, int64_t t, int length )
+{
+    VLC_UNUSED( length );
+
+    if ( pos == -1.f )
+        return;
+    
+    bool bFirstSet = false; 
+
+    long time = t / 1000;
+    int ms = time % 1000;
+    
+    time /= 1000;
+    int seconds = time % 60;
+
+    time /= 60;
+    int minutes = time % 60;
+
+    time /= 60;
+    int hours = time;
+
+    QTime newTime;
+    newTime.setHMS( hours, minutes, seconds, ms );
+        
+    if ( ( startTimeEdit->time() == QTime( 0,0,0 ) ) && ( endTimeEdit->time() == QTime( 0,0,0 ) ) )
+        bFirstSet = true;   /* On first use only, we need both times as the current marker */
+
+    /* update time and prevent circular updating by not triggeting the signal */
+    if ( bIsEditingEnd )
+    {
+        disconnect( endTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( endTimeUpdate( QTime ) ) );
+        endTimeEdit->setTime( newTime );
+        CONNECT( endTimeEdit, timeChanged( QTime ), this, endTimeUpdate( QTime ) );
+
+        if ( endTimeEdit->time() < startTimeEdit->time() )  //Avoid end before start
+        {
+            disconnect( startTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( startTimeUpdate( QTime ) ) );
+            startTimeEdit->setTime( newTime );
+            CONNECT( startTimeEdit, timeChanged( QTime ), this, startTimeUpdate( QTime ) );
+        }
+
+    }
+    if ( !bIsEditingEnd || bFirstSet )
+    {
+        disconnect( startTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( startTimeUpdate( QTime ) ) );
+        startTimeEdit->setTime( newTime );
+        CONNECT( startTimeEdit, timeChanged( QTime ), this, startTimeUpdate( QTime ) );
+
+        if ( endTimeEdit->time() < startTimeEdit->time() )  //Avoid end before start
+        {
+            disconnect( endTimeEdit, SIGNAL( timeChanged( QTime ) ), this, SLOT( endTimeUpdate( QTime ) ) );
+            endTimeEdit->setTime( newTime );
+            CONNECT( endTimeEdit, timeChanged( QTime ), this, endTimeUpdate( QTime ) );
+        }
+    }
+}
+
+/* sends playback commands according to the time set in the startTimeEdit */
+void EditEventDialog::startTimeUpdate( QTime newTime )
+{
+    int64_t i_time = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( newTime ) ) * 1000;
+
+    THEMIM->getIM()->setEventTimes( i_time, (int64_t)-1 );
+}
+
+/* sends playback commands according to the time set in the endTimeEdit */
+void EditEventDialog::endTimeUpdate( QTime newTime )
+{
+    int64_t i_time = (int64_t) ( QTime( 0, 0, 0 ).msecsTo( newTime ) ) * 1000;
+
+    THEMIM->getIM()->setEventTimes( (int64_t)-1, i_time );
+}
+
+/* Switches between editing the start or the end of the segment, with the last point where the marker was when swapped */
+void EditEventDialog::setEditingMode( bool bIsSegEndEdit )
+{
+    bIsEditingEnd = bIsSegEndEdit;
+
+    //updateSegTimes( 0, timeSwapped, 0 );  //ROIY is this happening before receiving the signal of updated?
+}
+
+EditEventDialog::~EditEventDialog()
+{
+    QVLCTools::saveWidgetPosition( p_intf, "EditEventDialog", this );
+    clear();
+}
\ No newline at end of file
diff --git a/modules/gui/qt4/dialogs/edit_event.hpp b/modules/gui/qt4/dialogs/edit_event.hpp
new file mode 100644
index 0000000..495d3c5
--- /dev/null
+++ b/modules/gui/qt4/dialogs/edit_event.hpp
@@ -0,0 +1,71 @@
+/*****************************************************************************
+ * edit_event.hpp : Edit Event
+ ****************************************************************************
+ * Copyright (C) 2006 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef QVLC_EDIT_EVENT_DIALOG_H_
+#define QVLC_EDIT_EVENT_DIALOG_H_ 1
+
+#include "util/qvlcframe.hpp"
+
+#include "util/singleton.hpp"
+
+#include <QDateTime>
+
+class QTextEdit;
+class QTimeEdit;
+class QTime;
+class QComboBox;
+
+class EditEventDialog : public QVLCDialog, public Singleton<EditEventDialog>
+{
+    Q_OBJECT
+private:
+    EditEventDialog( intf_thread_t * );
+    virtual ~EditEventDialog();
+    QGridLayout *mainLayout;
+    QComboBox *layersCombo;
+    QTimeEdit *orgStartTime;
+    QTimeEdit *startTimeEdit;
+    QTimeEdit *orgEndTime;
+    QTimeEdit *endTimeEdit;
+    QTextEdit *annotation_text;
+    seeksegment_t *p_event;
+    int eventIndex, eventLayer;
+    bool bIsEditingEnd;
+
+private slots:
+    friend class    Singleton<EditEventDialog>;
+    void editEvent();
+    void clear();
+    void update();
+    void close();
+
+public slots:
+    void setEditingMode( bool bIsSegEndEdit );
+    void updateSegTimes( float pos, int64_t t, int length );
+    void startTimeUpdate( QTime newTime );
+    void endTimeUpdate( QTime newTime );
+    void toggleVisible();
+};
+
+#endif
+
diff --git a/modules/gui/qt4/dialogs/event_properties.cpp b/modules/gui/qt4/dialogs/event_properties.cpp
new file mode 100644
index 0000000..93890b4
--- /dev/null
+++ b/modules/gui/qt4/dialogs/event_properties.cpp
@@ -0,0 +1,127 @@
+/*****************************************************************************
+ * events_properties.cpp : events_properties display
+ ****************************************************************************
+ * Copyright (C) 2006-2008 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "dialogs/event_properties.hpp"
+
+#include "main_interface.hpp" /* Needed for external MI size */
+#include "input_manager.hpp"
+
+#include <QDialogButtonBox>
+#include <QPushButton>
+#include <vlc_modules.h>
+
+EventPropertiesDialog::EventPropertiesDialog( intf_thread_t *_p_intf )
+               : QVLCDialog( (QWidget*)_p_intf->p_sys->p_mi, _p_intf )
+{
+#ifdef __APPLE__
+    setWindowFlags( Qt::Drawer );
+#else
+    setWindowFlags( Qt::Tool );
+#endif
+
+    setWindowOpacity( var_InheritFloat( p_intf, "qt-opacity" ) );
+    setWindowTitle( qtr( "Add New Event" ) );   //ROIY set according to command
+    setWindowRole( "vlc-eventProperties" );
+
+    QVBoxLayout *layout = new QVBoxLayout( this );
+    layout->setContentsMargins( 0, 0, 0, 0 );
+    layout->setSpacing( 1 );
+
+    eventPropertiesWidget = new EventPropertiesWidget( this , p_intf );
+    layout->addWidget( eventPropertiesWidget , 0 , Qt::AlignCenter );
+
+    QDialogButtonBox *saveButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    saveButtonBox->addButton(
+        new QPushButton( qtr("&Save"), this ), QDialogButtonBox::AcceptRole );
+
+    QDialogButtonBox *closeButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    closeButtonBox->addButton(
+        new QPushButton( qtr("&Close"), this ), QDialogButtonBox::RejectRole );
+
+    QHBoxLayout *buttonLayout = new QHBoxLayout( this );
+    buttonLayout->setSpacing( 0 );
+    buttonLayout->setContentsMargins( 0, 0, 0, 0 );
+    buttonLayout->addStretch( 1 );
+    buttonLayout->addWidget( saveButtonBox, 0 , Qt::AlignRight  );
+    buttonLayout->addWidget( closeButtonBox, 0 , Qt::AlignRight  );
+    layout->addLayout( buttonLayout );
+
+    CONNECT( closeButtonBox, rejected(), this, close() );
+    CONNECT( saveButtonBox, accepted(), eventPropertiesWidget, saveEvent() );
+    //CONNECT( saveButtonBox, accepted(), this, close() );
+    //CONNECT( closeButtonBox, rejected(), THEMIM->getIM(), eventsModified() ); ROIY FOR TEST
+    CONNECT( THEMIM->getIM(), eventsChanged( bool ), this, update( bool ) );
+
+    /* Restore geometry or move this dialog on the left pane of the MI */
+    if( !restoreGeometry( getSettings()->value("EventPropertiesPanel/geometry").toByteArray() ) )
+    {
+        resize( QSize( 400, 100 ) );
+
+        MainInterface *p_mi = p_intf->p_sys->p_mi;
+        if( p_mi && p_mi->x() > 50 )
+            move( ( p_mi->x() - frameGeometry().width() - 10 ), p_mi->y() );
+        else
+            move ( 450 , 0 );
+    }
+}
+
+EventPropertiesDialog::~EventPropertiesDialog()
+{
+    getSettings()->setValue("EventPropertiesPanel/geometry", saveGeometry());
+}
+
+void EventPropertiesDialog::update( bool inputExists )
+{
+    if ( !inputExists )
+        close();
+}
+
+void EventPropertiesDialog::close()
+{
+    THEMIM->getIM()->toggleEditing();
+    QVLCDialog::close();
+}
+
+void EventPropertiesDialog::show()
+{
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );    
+
+    eventPropertiesWidget->update( p_input != NULL );
+
+    if ( p_input )
+        vlc_object_release( p_input );
+
+    THEMIM->getIM()->toggleEditing();
+    QVLCDialog::show();
+}
+
+void EventPropertiesDialog::toggleVisible()
+{
+    if( isVisible() ) close();      //need the close function called...
+        else show();
+}
+
+
diff --git a/modules/gui/qt4/dialogs/event_properties.hpp b/modules/gui/qt4/dialogs/event_properties.hpp
new file mode 100644
index 0000000..14e346c
--- /dev/null
+++ b/modules/gui/qt4/dialogs/event_properties.hpp
@@ -0,0 +1,54 @@
+/*****************************************************************************
+ * events_properties.hpp : event properties dialogue
+ ****************************************************************************
+ * Copyright (C) 2006 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef QVLC_EVENT_PROPERTIES_DIALOG_H_
+#define QVLC_EVENT_PROPERTIES_DIALOG_H_ 1
+
+#include "components/event_properties_widget.hpp"
+#include "util/qvlcframe.hpp"
+
+#include "util/singleton.hpp"
+
+class QTabWidget;
+class QTextEdit;
+
+class EventPropertiesDialog : public QVLCDialog, public Singleton<EventPropertiesDialog>
+{
+    Q_OBJECT
+private:
+    EventPropertiesDialog( intf_thread_t * );
+    virtual ~EventPropertiesDialog();
+
+    EventPropertiesWidget *eventPropertiesWidget;
+
+private slots:
+    friend class    Singleton<EventPropertiesDialog>;
+    void update( bool inputExists );
+public slots:
+    void close();
+    void show();
+    void toggleVisible();
+};
+
+#endif
+
diff --git a/modules/gui/qt4/dialogs/events_layers.cpp b/modules/gui/qt4/dialogs/events_layers.cpp
new file mode 100644
index 0000000..821a3d8
--- /dev/null
+++ b/modules/gui/qt4/dialogs/events_layers.cpp
@@ -0,0 +1,111 @@
+/*****************************************************************************
+ * events_layers.cpp : events_layers display
+ ****************************************************************************
+ * Copyright (C) 2006-2008 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "dialogs/events_layers.hpp"
+
+#include "main_interface.hpp" /* Needed for external MI size */
+#include "input_manager.hpp"
+
+#include <QDialogButtonBox>
+#include <QPushButton>
+#include <QScrollArea>
+#include <QScrollBar>
+#include <vlc_modules.h>
+
+EventLayersDialog::EventLayersDialog( intf_thread_t *_p_intf )
+               : QVLCDialog( (QWidget*)_p_intf->p_sys->p_mi, _p_intf )
+{
+#ifdef __APPLE__
+    setWindowFlags( Qt::Drawer );
+#else
+    setWindowFlags( Qt::Tool );
+#endif
+
+    setWindowOpacity( var_InheritFloat( p_intf, "qt-opacity" ) );
+    setWindowTitle( qtr( "Events Layers" ) );
+    setWindowRole( "vlc-eventLayers" );
+
+    QVBoxLayout *layout = new QVBoxLayout( this );
+    layout->setContentsMargins( 0, 0, 0, 0 );
+    layout->setSpacing( 1 );
+
+    eventsLayersWidget = new EventsLayersWidget( this , p_intf );
+    QScrollArea *scroller= new QScrollArea;
+    QSizePolicy sizePolicy( QSizePolicy::Fixed, QSizePolicy::Expanding );
+    sizePolicy.setHorizontalStretch( 0 );
+    scroller->setSizePolicy( sizePolicy );
+    scroller->setFrameStyle( QFrame::NoFrame );
+    scroller->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
+    scroller->setWidgetResizable(true);
+    scroller->setWidget( eventsLayersWidget );
+    scroller->setMinimumWidth(eventsLayersWidget->minimumSizeHint().width() + scroller->verticalScrollBar()->width() + 2);
+    layout->addWidget( scroller , 0 , Qt::AlignCenter );
+
+
+    QPushButton *addAllButton = new QPushButton( qtr("&Add All"), this );
+    QPushButton  *removeAllButton = new QPushButton( qtr("&Remove All"), this );
+
+    QDialogButtonBox *closeButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    closeButtonBox->addButton(
+        new QPushButton( qtr("&Close"), this ), QDialogButtonBox::RejectRole );
+
+    QHBoxLayout *buttonLayout = new QHBoxLayout( this );
+    buttonLayout->setSpacing( 0 );
+    buttonLayout->setContentsMargins( 0, 0, 0, 0 );
+    buttonLayout->addWidget( addAllButton , 0 , Qt::AlignLeft );
+    buttonLayout->addWidget( removeAllButton , 0 , Qt::AlignLeft );
+    buttonLayout->addStretch( 1 );
+    buttonLayout->addWidget( closeButtonBox, 0 , Qt::AlignRight  );
+    layout->addLayout( buttonLayout );
+
+    CONNECT( addAllButton, released(), eventsLayersWidget, addAll() );
+    CONNECT( removeAllButton, released(), eventsLayersWidget, removeAll() );
+    CONNECT( closeButtonBox, rejected(), this, close() );
+    CONNECT( THEMIM->getIM(), eventsChanged( bool ), this, update( bool ) );
+
+    /* Restore geometry or move this dialog on the left pane of the MI */
+    if( !restoreGeometry( getSettings()->value("EventLayersPanel/geometry").toByteArray() ) )
+    {
+        resize( QSize( 400, 100 ) );
+
+        MainInterface *p_mi = p_intf->p_sys->p_mi;
+        if( p_mi && p_mi->x() > 50 )
+            move( ( p_mi->x() - frameGeometry().width() - 10 ), p_mi->y() );
+        else
+            move ( 450 , 0 );
+    }
+}
+
+EventLayersDialog::~EventLayersDialog()
+{
+    getSettings()->setValue("EventLayersPanel/geometry", saveGeometry());
+}
+
+void EventLayersDialog::update( bool inputExists )
+{
+    if ( !inputExists )
+        close();
+}
diff --git a/modules/gui/qt4/dialogs/events_layers.hpp b/modules/gui/qt4/dialogs/events_layers.hpp
new file mode 100644
index 0000000..d88dfc8
--- /dev/null
+++ b/modules/gui/qt4/dialogs/events_layers.hpp
@@ -0,0 +1,50 @@
+/*****************************************************************************
+ * events_layers.hpp : events layers dialogue
+ ****************************************************************************
+ * Copyright (C) 2006 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef QVLC_EVENTS_LAYERS_DIALOG_H_
+#define QVLC_EVENTS_LAYERS_DIALOG_H_ 1
+
+#include "components/events_layers_widget.hpp"
+#include "util/qvlcframe.hpp"
+
+#include "util/singleton.hpp"
+
+class QTabWidget;
+class QTextEdit;
+
+class EventLayersDialog : public QVLCDialog, public Singleton<EventLayersDialog>
+{
+    Q_OBJECT
+private:
+    EventLayersDialog( intf_thread_t * );
+    virtual ~EventLayersDialog();
+
+    EventsLayersWidget *eventsLayersWidget;
+
+private slots:
+    friend class    Singleton<EventLayersDialog>;
+    void update( bool inputExists );
+};
+
+#endif
+
diff --git a/modules/gui/qt4/dialogs/new_layer.cpp b/modules/gui/qt4/dialogs/new_layer.cpp
new file mode 100644
index 0000000..9e8f0f6
--- /dev/null
+++ b/modules/gui/qt4/dialogs/new_layer.cpp
@@ -0,0 +1,147 @@
+/*****************************************************************************
+ * new_layer.cpp : new_layer display
+ ****************************************************************************
+ * Copyright (C) 2006-2008 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "dialogs/new_layer.hpp"
+
+#include <QPushButton>
+#include <QLineEdit>
+#include <QLabel>
+#include <QDialogButtonBox>
+#include <QMessageBox>
+
+
+NewLayerDialog::NewLayerDialog( intf_thread_t *_p_intf )
+               : QVLCDialog( (QWidget*)_p_intf->p_sys->p_mi, _p_intf )
+{
+#ifdef __APPLE__
+    setWindowFlags( Qt::Drawer );
+#else
+    setWindowFlags( Qt::Window );
+#endif
+
+    setWindowOpacity( var_InheritFloat( p_intf, "qt-opacity" ) );
+    setWindowTitle( qtr( "Add New Events Layer" ) );
+    setWindowRole( "vlc-newLayer" );
+
+    QGridLayout *mainLayout = new QGridLayout( this );
+    mainLayout->setContentsMargins( 1, 1, 1, 1 );
+    mainLayout->setSpacing( 2 );
+    mainLayout->setSizeConstraint( QLayout::SetFixedSize );
+
+    QLabel *addIntro = new QLabel( qtr( "Add New Layer:" ) );
+    addIntro->setAlignment( Qt::AlignCenter );
+    
+    mainLayout->addWidget( addIntro, 0, 0, 1, 1 );
+    
+    layerName = new QLineEdit();
+
+    mainLayout->addWidget( layerName, 0, 1, 1, 1 );
+
+
+    QDialogButtonBox *saveButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    saveButtonBox->addButton(
+        new QPushButton( qtr("&Add"), this ), QDialogButtonBox::AcceptRole );
+
+    QDialogButtonBox *closeButtonBox = new QDialogButtonBox( Qt::Horizontal, this );
+    closeButtonBox->addButton(
+        new QPushButton( qtr("&Cancel"), this ), QDialogButtonBox::RejectRole );
+
+    QHBoxLayout *buttonLayout = new QHBoxLayout( this );
+    buttonLayout->setSpacing( 0 );
+    buttonLayout->setContentsMargins( 0, 0, 0, 0 );
+    buttonLayout->addStretch( 1 );
+    buttonLayout->addWidget( saveButtonBox, 0 , Qt::AlignRight  );
+    buttonLayout->addWidget( closeButtonBox, 0 , Qt::AlignRight  );
+    mainLayout->addLayout( buttonLayout, 1, 0, 1, 2 );
+
+    CONNECT( closeButtonBox, rejected(), this, close() );
+    CONNECT( saveButtonBox, accepted(), this, addLayer() );
+
+    QVLCTools::restoreWidgetPosition( p_intf, "NewLayerDialog", this );
+
+    layerName->setFocus();
+}
+
+void NewLayerDialog::toggleVisible()
+{
+    QVLCDialog::toggleVisible();
+    layerName->setFocus();
+}
+
+void NewLayerDialog::close()
+{
+    layerName->clear();
+    toggleVisible();
+}
+
+NewLayerDialog::~NewLayerDialog()
+{
+    QVLCTools::saveWidgetPosition( p_intf, "NewLayerDialog", this );
+}
+
+void NewLayerDialog::addLayer()
+{
+    if ( layerName->text().isEmpty() )
+    {
+        QMessageBox msgBox;
+        msgBox.setText( "<p align='center'>Please enter a name for the new Layer</p>" );
+        msgBox.exec();
+        return;
+    }
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    int* pi_layers;
+    char*** psz_layerNames;
+    if ( input_Control( p_input, INPUT_GET_LAYER_NAMES, &psz_layerNames, &pi_layers ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    vlc_object_release( p_input );
+
+    const char* newLayer = (const char*) qtu( layerName->text() );
+    
+    for ( int i = 0 ; i < *pi_layers ; i++ )
+    {
+        if ( strnicmp( (*psz_layerNames)[i], newLayer, 255 ) == 0 )  /* Layer found, no need to add */
+        {
+            QMessageBox msgBox;
+            msgBox.setText( "<p align='center'>This layer name already exists.</p>" );
+            msgBox.exec();
+
+            close();
+            return;
+        }
+    }   
+            
+
+    emit layerAdded( layerName->text() );
+    close();
+}
\ No newline at end of file
diff --git a/modules/gui/qt4/dialogs/new_layer.hpp b/modules/gui/qt4/dialogs/new_layer.hpp
new file mode 100644
index 0000000..580f33a
--- /dev/null
+++ b/modules/gui/qt4/dialogs/new_layer.hpp
@@ -0,0 +1,55 @@
+/*****************************************************************************
+ * new_layer.hpp : New layer name
+ ****************************************************************************
+ * Copyright (C) 2006 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef QVLC_NEW_LAYER_DIALOG_H_
+#define QVLC_NEW_LAYER_DIALOG_H_ 1
+
+#include "util/qvlcframe.hpp"
+
+#include "util/singleton.hpp"
+
+class QLineEdit;
+
+class NewLayerDialog : public QVLCDialog, public Singleton<NewLayerDialog>
+{
+    Q_OBJECT
+private:
+    NewLayerDialog( intf_thread_t * );
+    virtual ~NewLayerDialog();
+    QWidget* _parent;
+    QLineEdit* layerName;
+
+private slots:
+    friend class    Singleton<NewLayerDialog>;
+    void close();
+
+signals:
+    void layerAdded( QString );
+
+public slots:
+    void addLayer();
+    void toggleVisible();
+};
+
+#endif
+
-- 
1.8.3.msysgit.0

